#include "3dMath.h"

/*	KONTRUKTORY */
Vector3f::Vector3f()
{
	/*	Tu adna rewelacja.
		Po prostu zerujemy
		skadowe.
	*/
	X = 0.0f;
	Y = 0.0f;
	Z = 0.0f;
}

Vector3f::Vector3f( const Vector3f& V1 )
{
	/*	Tu przypisujemy
		skadowym wartoci
		skadowych wektora V1
	*/
	X = V1.X;
	Y = V1.Y;
	Z = V1.Z;
}

Vector3f::Vector3f( const float x, const float y, const float z )
{
	/*	Niewielka rnica w stosunku
		do poprzedniej metody. Po prostu
		przypisujemy podane wartoci.
	*/
	Set( x, y, z );
}

/*	DESTRUKTOR	*/
Vector3f::~Vector3f()
{
	// Raczej nie ma czego usuwa :P
}

/*	METODA USTAWIAJCA
	Duo ona nie robi, po prostu
	przypisuje wartoci do skadowych.
*/
Vector3f Vector3f::Set( const float x, const float y, const float z )
{
	X = x;
	Y = y;
	Z = z;

	// Przy okazji zwracamy ten wektor, by nie mie konflikw, przy rnych operacjach
	return *this;
}

/*	OPERATORY
	Dziaenie ty opertorw
	jest na tyle proste, e
	nie bde ich opisywa.
	( czyt. nie chce mi si :P )
*/
Vector3f Vector3f::operator=( const Vector3f V1 )
{
	Set( V1.X, V1.Y, V1.Z );
	return *this;
}

Vector3f Vector3f::operator=( const float V1 )
{
	Set( V1, V1, V1 );
	return *this;
}

Vector3f Vector3f::operator+( const Vector3f V1 )
{
	Vector3f zwrot;
	zwrot.Set( X + V1.X, Y + V1.Y, Z + V1.Z );
	return zwrot;
}

Vector3f Vector3f::operator+( const float V1 )
{
	Vector3f zwrot;
	zwrot.Set( X + V1, Y + V1, Z + V1 );
	return zwrot;	
}

Vector3f Vector3f::operator-( const Vector3f V1 )
{
	Vector3f zwrot;
	zwrot.Set( X - V1.X, Y - V1.Y, Z - V1.Z );
	return zwrot;
}

Vector3f Vector3f::operator-( const float V1 )
{
	Vector3f zwrot;
	zwrot.Set( X - V1, Y - V1, Z - V1 );
	return zwrot;	
}

Vector3f Vector3f::operator*( const Vector3f V1 )
{
	Vector3f zwrot;
	zwrot.Set( X * V1.X, Y * V1.Y, Z * V1.Z );
	return zwrot;
}

Vector3f Vector3f::operator*( const float V1 )
{
	Vector3f zwrot;
	zwrot.Set( X * V1, Y * V1, Z * V1 );
	return zwrot;	
}

Vector3f Vector3f::operator/( const Vector3f V1 )
{
	Vector3f zwrot;
	zwrot.Set( X / V1.X, Y / V1.Y, Z / V1.Z );
	return zwrot;
}

Vector3f Vector3f::operator/( const float V1 )
{
	Vector3f zwrot;
	zwrot.Set( X / V1, Y / V1, Z / V1 );
	return zwrot;	
}

Vector3f Vector3f::operator+=( const Vector3f V1 )
{
	return *this = *this + V1;
}

Vector3f Vector3f::operator+=( const float V1 )
{
	return *this = *this + V1;
}

Vector3f Vector3f::operator-=( const Vector3f V1 )
{
	return *this = *this - V1;
}

Vector3f Vector3f::operator-=( const float V1 )
{
	return *this = *this - V1;
}

Vector3f Vector3f::operator*=( const Vector3f V1 )
{
	return *this = *this * V1;
}

Vector3f Vector3f::operator*=( const float V1 )
{
	return *this = *this * V1;
}

Vector3f Vector3f::operator/=( const Vector3f V1 )
{
	return *this = *this / V1;
}

Vector3f Vector3f::operator/=( const float V1 )
{
	return *this = *this / V1;
}

/*	METODY SPECJALNE	*/

/*	CROSS PRODUCT
	Dziki tej funkcji otrzymamy wektor
	prostopady do dwch pozostaych
	wektorw.
*/
Vector3f Vector3f::Cross( const Vector3f V1 )
{
	Vector3f zwrot;
	zwrot.X = ( Y * V1.Z ) - ( V1.Y * Z );
	zwrot.Y = ( X * V1.Z ) - ( V1.X * Z );
	zwrot.Z = ( X * V1.Y ) - ( V1.X * Y );

	return zwrot;
}

/*	DOT PRODUCT
	Hmm trudno mi wyjani do czego
	suy ta metoda. Zwraca ona liczb
	zmiennoprzecinkow i... Sami si
	zreszt przekonacie :P
*/
float Vector3f::Dot( const Vector3f V1 )
{
	return X * V1.X + Y * V1.Y + Z * V1.Z;
}

/*	DUGO
	W przypadku wektorw mona atwo
	policzy ich dugo. Poniej podana
	metoda jest po prostu rozwiniciem
	wzoru Pitagorasa ( dodano 3 wymiar :) )
*/
float Vector3f::Leangth()
{
	return sqrtf( X * X + Y * Y + Z * Z );
}

/*	NORMALIZACJA
	Normalizacja jest skrceniem wektora
	do dugoci rwnej 1. Najprociej to
	wykona poprzez dzielenie jego skadowych
	przez jego dotychczasow dugo.
*/
Vector3f Vector3f::Normalize()
{
	float len = Leangth();
	X /= len;
	Y /= len;
	Z /= len;

	return *this;
}

/*	ODWRCENIE
	No chyba nie powiecie, e si nie
	domylacie :)
*/
Vector3f Vector3f::Reverse()
{
	Vector3f zwrot;
	zwrot.Set( -X, -Y, -Z );
	return zwrot;
}

/*	DYSTANS
	Ta funkcja oblicza odlego
	midzy dwoma punktami.
*/
Vector3f Dummy::GetBlockPos()
{
	Vector3f zwrot;
	zwrot.X = float( (int)Pos.X / 10 );
	zwrot.Z = -float( (int)Pos.Z / 10 );
	return zwrot;
}

float mathDist( Vector3f V1, Vector3f V2 )
{
	Vector3f vect = V2 - V1;
	return vect.Leangth();
}

Vector3f ClosestPoint( Vector3f V1, Vector3f V2, Vector3f Point )
{
	Vector3f Vect1, Vect2;
	Vect1 = Point - V1;
	Vect2 = V2 - V1;
	Vect2.Normalize();
	float d = mathDist( V1, V2 );
	float t = Vect2.Dot( Vect1 );

	if( t <= 0 )
		return V1;

	if( t >= d )
		return V2;

	Vector3f Wynik = V1 + Vect2 * t;

	return Wynik;
}

float GetAngle( Vector3f V1, Vector3f V2 )
{
	
	float R = fabsf( mathDist( V1, V2 ) );

	float sinus = ( V2.X - V1.X ) / R; 
	float cosinus = ( V2.Z - V1.Z ) / R;

	//wyliczamy dwa nowe katy na podstawie arc sin i cos
	float kat = asinf(sinus) / PIOVER180;
	float kat2 = acosf(cosinus) / PIOVER180;

	//porwnujemy, jeeli oba kty s wiksze 
	//od zera to zwracamy ten oparty na arc cos
	if(kat >= 0 && kat2 >= 0)
	{
		return kat2;
	}
	//jednak jeeli kt na podstawie arc sin jest mniejszy od zera
	//to zwracamy kt jaki powstanie gdy od penego okrgu odejmniemy
	//kt na podstawie arc cos (jest dodatni) wtedy uzyskamy prawdziwy
	//kt
	else if(kat < 0 && kat2 > 0)
	{
		float rkat = 360.0f - kat2;

		return rkat;
	}
	else return 0.0f;
}

float SwapAngle( float Angle )
{
	if( Angle < 0.0f )
		Angle += 360.0f;
	if( Angle > 360.0f )
		Angle -= 360.0f;
	return Angle;
}