#ifndef _3DMATH_H_
#define _3DMATH_H_

#include <math.h>

#define PIOVER180  0.0174532925199432957692369076848861f

/*	KLASA WEKTORW
	Ta klasa bardzo si przyda przy
	grafice 3D. Jako, e zaley nam
	na prostocie, bdzie jednoczenie
	suya za wierzchoek i wektor, oraz
	punkty 2D i 3D.
*/
class Vector3f
{
public:
	//	Skadowe
	float X, Y, Z;

	// Konstruktory i Destruktor
	Vector3f();
	Vector3f( const Vector3f& V1 );
	Vector3f( const float x, const float y, const float z );
	~Vector3f();

	// Funkcja ustawiajca wszystkie skadowe na raz ( by byo mniej pisania :P )
	Vector3f Set( const float x, const float y, const float z );

	/*	OPERATORY
		By ta klasa bya uyteczna, to musi
		mie operatory, by mc operowa na
		tych obiektach. Mogem zrobi oddzielne
		funkcje i operowa na strukturze, ale
		to przecie C++ a nie C ;)
	*/
	//	operator przypisania
	Vector3f operator=( const Vector3f V1 );
	Vector3f operator=( const float V1 );

	// operator dodawania
	Vector3f operator+( const Vector3f V1 );
	Vector3f operator+( const float V1 );

	// operator odejmowania
	Vector3f operator-( const Vector3f V1 );
	Vector3f operator-( const float V1 );

	// operator mnoenia
	Vector3f operator*( const Vector3f V1 );
	Vector3f operator*( const float V1 );

	// operator dzielenia
	Vector3f operator/( const Vector3f V1 );
	Vector3f operator/( const float V1 );

	// operatory czone:
	Vector3f operator+=( const Vector3f V1 );
	Vector3f operator+=( const float V1 );
	Vector3f operator-=( const Vector3f V1 );
	Vector3f operator-=( const float V1 );
	Vector3f operator*=( const Vector3f V1 );
	Vector3f operator*=( const float V1 );
	Vector3f operator/=( const Vector3f V1 );
	Vector3f operator/=( const float V1 );	

	/*	METODY SPECJALNE
		W grafice 3D wystpuje kilka
		bardzo przydatnych wzorw, ktre
		operuj na wierzchokach i wektorach.
		By korzysta z tych dobrodziejstw
		napisaem wbudowane metody.
		( BTW: Kiedy robiem to na
		odzielnych funkcjach, ale to
		tylko wprowadzao zamt w kodzie :P )
	*/
	// CrossProduct
	Vector3f Cross( const Vector3f V1 );

	// DotProduct
	float Dot( const Vector3f V1 );

	// Dugo wektora
	float Leangth();

	// Normalizacja
	Vector3f Normalize();

	// Odwrcenie
	Vector3f Reverse();
};

/*	KLASA PASZCZYZN
	Paszczyzna, to niczym nie ograniczona
	powieszchnia, ktra posiada tylko kierunek
	przedni oraz przesunicie. Jest BARDZO
	przydatna jeeli chodzi o grafike 3D.
*/
class Planef
{
public:
	Vector3f Normal;
	float D;
};

/*	KLASA KUK :)
	Su mi do wykrywania kolizji midzy
	obiektami rnych klas. Wikszo
	obiektw sceny z niej dzidziczy.
*/
class Dummy
{
public:
	Dummy(){ R = 3.0f; };
	Vector3f	Pos;
	Vector3f	NextPos;
	Vector3f	Vector;
	float R;

	Vector3f GetBlockPos();
};

extern float mathDist( Vector3f V1, Vector3f V2 );
extern Vector3f ClosestPoint( Vector3f V1, Vector3f V2, Vector3f Point );
extern float GetAngle( Vector3f V1, Vector3f V2 );
extern float SwapAngle( float Angle );

#endif