#include "Render.h"

UIRender GLRender;
/* KONSTRUKTOR
	Inicjalizacja zmienych, czyli
	ustalenie poczatkowych wartosci
*/
UIRender::UIRender()
{
	hDC = NULL; // Przeciez na razie nia ma
	hRC = NULL; // adnego kontekstu, dlatego
	hWnd = NULL;// zerujemy te zmienne
	hInstance = NULL;
	
	IsPers = false; // Na poczatku nie potrzebujemy perspektywy
	fullS = true;	// Na pocztku lepiej ustawi peny ekran
	IsWin = false;	// Przecie na pocztku nie mamy okna!
	ColBits = -1;	// Domylna warto dla bitw kolorw

	// Domylne wartoci dla rozmiaru okna ( patrz->deklaracja )
	ScrSize[0] = 1;
	ScrSize[1] = 1;

	// Domyslne wartosci dla perspektywy ( patrz->deklaracja tablicy )
	PerConf[0] = 45.0f;
	PerConf[1] = 1.0f;
	PerConf[2] = 1.0f;
	PerConf[3] = 100.0f;

	// Domyslne wartosci dla rzutowania prostokatnego ( patrz->deklaracja tablicy )
	OrthoConf[0] = -1.0f;
	OrthoConf[1] = 1.0f;
	OrthoConf[2] = -1.0f;
	OrthoConf[3] = 1.0f;
	OrthoConf[4] = -1.0f;
	OrthoConf[5] = 1.0f;

	/*
		RndInfo domylnie s puste, bo informacje otrzymamy
		dopiero po inicjalizacji kontekstu renderujcego (hRC).
		Klasa std::string automatycznie ju ustawia puste
		acuchy znakw.
	*/
}

/*	DESTRUKTOR	*/
UIRender::~UIRender()
{

}

/*	USTAWIENIE WSKANIKA
	By wogle zainicjalizowa okno i kontekst
	musimy mie uchwyt na okno. Mogem go wkodowa
	ju w klasie, ale to utrudni niektre rzeczy,
	dlatego postanowiem ustawi tylko wskanik.
*/
void UIRender::SetWinHandle( HWND* Uchwyt )
{
	if( IsWin ) return; // Jeeli okno jest stworzone, to stracenie wskanika
						// byo by katastrof! Dlatego przerywamy metod.

	Log.Log( "Ustawianie uchwytu Okna" );
	hWnd = Uchwyt; // Ustawiamy uchwyt, przez przekazanie adresu ( najprociej )
}

/*	TWORZENIE OKNA
	Majc Uchwyt moemu ju stworzy okno... No prawie :)
	Potrzebne jeszcze dane to:
	Tytul	- Tytu okna ( ten napis na belce )
	Szerokosc, Wysokosc - Wysoko i Szeroko okna, jak sobie yczymy
	FullScr	- Czy ma by na penym ekranie
	WndProc	- Funkcja obsugi komunikatw Windowsa ( musi by z zewntrz, takie zasady C++ :P )
*/
bool UIRender::GLCreateWindow( std::string Tytul, int Szerokosc, int Wysokosc, bool FullScr, WNDPROC WndProc )
{
	Log.Log( "Tworzenie Okna" );
	/* Na pocztku musimy ustawi zmienne pomocnicze */

	/*	By stworzy okno, potrzebna jest jego definicja,
		a tak moemy przekaza, przez strukture typu
		WNDCLASS.
	*/
	WNDCLASS	wc;				//Struktura klasy okna

	/*	Dalej s tzw. style okna. dwStyle trzyma
		bezwzgldny styl ( taki jak, czy to okno jest wyskakujce, czy zewnrzne )
		dwExStyle trzyma wygld okna ( np. czy ma krawdzie i belk tytuow ).
		Oba typy s DWORD ( czyli unsigned int, jakby kto pyta )
	*/
	DWORD		dwExStyle;				//Zewntrzny styl okna
	DWORD		dwStyle;				//Styl Okna

	/*	Potrzebny jest jeszcze tylko prostokt. Jest potrzebny
		By okreli rozmiar i poorzenie okna. Jest to po prostu
		struktura z 4 zmiennymi typu long int.
	*/
	RECT		WindowRect;				//Wielko okna (struktura czworoboku)

	/*	Na pocztku ustawiamy prostokt okna. */
	WindowRect.left		= (long)0;			//Lewa krawd na 0
	WindowRect.right	= (long)Szerokosc;	//Prawa krawd na warto Szerokosc
	WindowRect.top		= (long)0;			//Grna krawd na 0
	WindowRect.bottom	= (long)Wysokosc;	//Dolna krawd na warto Wysokosc

	// Przy okazji ustawiamy tablice z rozmiarem, by potem by atwiejszy dostp w caej klasie
	ScrSize[0] = Szerokosc;
	ScrSize[1] = Wysokosc;

	// Oraz ustawiamy czy wszystko jest w penym ekranie
	fullS = FullScr;

	// apiemy instancje ( jest potrzebna do wikszoci zada z oknem )
	hInstance			= GetModuleHandle(NULL);

	// Okrelamy paramerty okna dziki strukturze WNDCLASS

	/*	Styl Bezwgldny okna
		Tu ustawiamy, e okno moe
		by odrysowywane, oraz, e 
		posiada wasny kontekst.
	*/	
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	

	// Tu podajemy funkcje obsugi komunikatw tego okna.
	wc.lpfnWndProc		= WndProc;	

	// wtf? Lepiej zostawic w spokoju...
	wc.cbClsExtra		= 0;	// ?
	wc.cbWndExtra		= 0;	// ?		
	
	// Tu podajemy instancje
	wc.hInstance		= hInstance;	

	// adujemy ikone aplikacji (widoczn na belce okna) oraz kursor (bez zmia, bo po co?)
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			//Ustaw standardow ikon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			//Ustaw zwyky wskanik myszy

	// A po cholere nam podkad i menu, gdy i tak wszystko bdzie rysowane na wierzchu?
	wc.hbrBackground	= NULL;	//Brak podkadu
	wc.lpszMenuName		= NULL;	//Bez menu okna

	// Jeszcze potrzebna nazwa tej klasy okna
	wc.lpszClassName	= "OpenGL";	//Nazwa klasy okna

	/*	Teraz rejestrujemy klas okna.
		Windows posiada swj wasny rejestr klas okna
		i eby stworzy jakie nowe okno, to trzeba
		poda jego klas. Jako, e my chcemy stworzy
		niestandardowe okno ( z OpenGL ) to musimy
		zarejestrowa wasn klas okna.
	*/
	if (!RegisterClass(&wc)) //Prba rejestracji okna
	{
	    //Gdy nieudana, wywietlamy odpowieni komunikat
		Log.FatalError( "Nie mona zarejestrowa klasy okna!" );
		return false;	//przerwij i zwr, e inicjalizacja nie udana.
	}
	
	/*	Teraz ustwiamy peny ekran.
		Mamy ju do tego wszystkie potrzebne informacje
		( oczywicie jeeli chcemy peny ekran.
	*/
	if (fullS)
	{
		// struktura trzymajca konfiguracje zmiany parametrw ekranu			
		DEVMODE dmScreenSettings;

        // Musimy t struktur przeczyci (nadpisa zerami), by nie mie adnych niespodzianek					
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);
		
        //ustawiamy strukture	
		dmScreenSettings.dmPelsWidth	= ScrSize[0];	//Szeroko ekranu
		dmScreenSettings.dmPelsHeight	= ScrSize[1];	//Wysoko ekranu
		dmScreenSettings.dmBitsPerPel	= 32;		//Gbia kolorw

		// Ostatnie ustawienie mwi, co zrobi z Pixelami
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		/*	Prba zmiany rozdzielczoci (CDS_FULLSCREEN usuwa 
			panel startu, oraz przywraca star konfiguracje ekranu
			przy kolejnej prbie zmiany rozdzielczo )
		*/
		Log.Log( "Zmiana rozdzielczoci" );
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
		{
			Log.Error( "Nie mona zmieni rozdzielczoci!" );
			//Jeeli nieudana, proponujemy dziaanie okienkowe
			if (MessageBox(NULL,"Nie mona zmieni rozdzielczoci. Prawdopodobnie\ntwoja karta graficzna nie obsuguje trybu Penoekranowego.\nUy trybu okienkowego?","OpenGL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				Log.Report( "Zmiana trybu na Okienkowy" );
                //Jeeli tak to wykonujemy
				fullS = false;
			}
			else
			{
				//Jeeli nie to koczymy dziaanie (dajemy komunikat, e progam zostanie zamknity)
				MessageBox(NULL,"Program zostanie zamknity.","BD",MB_OK|MB_ICONSTOP);
				Log.Report( "Wyczenie aplikacji" );
				return false;	//przerywamy dziaanie aplikacji
			}
		}
	}

	//Ustawiamy styl okna w zalenoci, czy jest ustawiony peny ekran
	if( fullS )	
	{
		dwExStyle=WS_EX_APPWINDOW;	// ? 
		dwStyle=WS_POPUP;			// Okienko bez niczego ( tylko rodek okna )
		ShowCursor( false );		// Schowaj kursor myszy
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;	// ?
		dwStyle=WS_OVERLAPPEDWINDOW;	/*	Okno z belk (ktra ma wszystkie przyciski typu
											Minimalizuj, itp ), z krawdzi i tytuem
										*/
	}
	
	//Ustawiamy styl okna
	AdjustWindowRectEx( &WindowRect, dwStyle, false, dwExStyle );		

	// Ostatecznie tworzymy okno
	if (!(*hWnd=CreateWindowEx(	dwExStyle,							//Styl zewntrzny okna
								"OpenGL",							//Nazwa klasy okna
								Tytul.c_str(),						//Tytu okna (na belce)
								dwStyle |							//Definicja stylu
								WS_CLIPSIBLINGS |					
								WS_CLIPCHILDREN,					
								0, 0,								//Pozycja okna
								WindowRect.right-WindowRect.left,	//Szeroko okna (z oblicze)
								WindowRect.bottom-WindowRect.top,	//Wysoko okna (z oblicze)
								NULL,								//Brak okna-matki
								NULL,								//Bez Menu
								hInstance,							//Uchwyt pamici
								NULL)))								//Nic nie informuj przez WM_CREATE
	{
	 	//Jeeli si nie uda					
		GLDestroyWindow();		//Niszczymy okno
		Log.FatalError( "Bd tworzenia okna!" );
		return false;	//koczymy dziaanie
	}

	IsWin = true;

	if( !EnableGL() )
	{
		GLDestroyWindow();
		return false;
	}
	
	Log.Log( "Tworzenie okna zakoczone." );
	return true;
}

/*	INICJACJA OPENGL
	Tu si odbywa waciwa inicjacja OpenGL.
	Moliwe jest przypisanie klasie zewntrznego
	uchwytu do okna i inicjalizacja na nim, poprzez
	rczne wywoanie tej metody.
*/
bool UIRender::EnableGL()
{
	Log.Log( "Inicjalizacja OpenGL" );
	/*	Na pocztku zmienna trzymajca wynik
		wyszukiwania ustawie dla danego
		formatu ustawie (dziwnie brzmi, ale jest potrzebne :P )
	*/
	unsigned int   PixelFormat;			//Wynik wyszukiwania

	/*	Najperw musimy wycign z Windows aktualn palet kolorw.
		Dlaczego? Nie wiadomo, ale na niektreych windowsach na penym
		ekranie, gdy ustawiamy inn palete ni jest na pulpicie
		to si dziej rne nieprzyjemne rzeczy :P. Najprociej
		t informacje wycign przez PixelFormat. Do tego jest
		potrzebny kontekst (DC), z ktrego wycigamy informacje, a
		do tego z kolei potrzebny jest uchwyt okna ( bo windows
		traktuje pulpit jak jedno ogromne okno ).
	*/
	if( ColBits == -1 ) // sprawdzamy, czy casem informacja nie zostaa ju wycignita
	{
		HDC deskDC = GetWindowDC( GetDesktopWindow() );
		PixelFormat = GetPixelFormat( deskDC );

		// Teraz rozpisujemy otrzyman informacje
		PIXELFORMATDESCRIPTOR tempPFD;
		DescribePixelFormat( deskDC, PixelFormat, sizeof( PIXELFORMATDESCRIPTOR ), &tempPFD );

		// Wreszcie pobieramy upragnion informacje
		ColBits = tempPFD.cColorBits;
	}

	// Teraz ustwaiamy format pixeli ( jednorazowo, std static )
	static	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),	// Rozmiar
		1,								// Numer wersji
		PFD_DRAW_TO_WINDOW |			// Musi wspiera zwyke okno
		PFD_SUPPORT_OPENGL |			// Musi wspiera OpenGL
		PFD_DOUBLEBUFFER,				// Musi wspiera podwjne buforowanie
		PFD_TYPE_RGBA,					// Tryb kolorw RGBA
		ColBits,						// Ggia kolorw
		0, 0, 0, 0, 0, 0,				// Ignorowane bity kolorw (adne)
		0,								// Bez bufora kanau Alfa
		0,								// Shift Bit Ignored
		0,								// No Accumulation Buffer
		0, 0, 0, 0,						// Accumulation Bits Ignored
		16,								// Wielko bufora gbokoci (16bit) 
		0,								// Bufor Stencil (Wczony, na wszelki wypadek)
		0,								// Bufor Aux'a
		PFD_MAIN_PLANE,					// Gdzie rysowa
		0,								// Zarezerwowane
		0, 0, 0							// Maski Warstw (ignorowane)
	};
	
	// Pobieramy kontekst dla okna z uchwytu (* jest dodane, by uzyska sam uchwyt, nie wskanik )
	if (!(hDC=GetDC(*hWnd)))
	{
		// Jeeli si nie udaje
		Log.FatalError( "Nie mona stworzy kontekstu GL!." );
		return false;								
	}

	// Teraz szukamy odpowiednich ustawie w dostpnych
	if (!(PixelFormat = ChoosePixelFormat( hDC, &pfd )))
	{
		Log.FatalError( "Nie mona znale odpowiedniego PixelFormat'u." );
		return false;								
	}

	// Sprbujmy teraz wprowadzi nasze ustawienia
	if(!SetPixelFormat(hDC,PixelFormat,&pfd))
	{
		Log.FatalError( "Nie mona ustawic Pixel Formatu." );
		return false;								
	}

	/*	Teraz tworzymy kontekst renderujcy OpenGL
		Bez niego nie mona korzysta z wikszoci
		funkcji w OpenGL ( w kadym razie - nie 
		ma sensu go nie tworzy ).]
	*/
	if (!(hRC=wglCreateContext(hDC)))
	{
		Log.FatalError( "Nie mona stworzy kontekstu renderujcego!." );
		return false;								
	}

	/*	A teraz trzeba uaktywni nasz kontekst OpenGL
		Wedug specyfikacji moemy mie kilka kontekstw
		i si przencza midzy nimi, ale my mamy tylko
		jeden :P ( proste nie? )
	*/
	if(!wglMakeCurrent(hDC,hRC))
	{
		Log.FatalError( "Nie mona aktywowa kontekstu." );
		return false;								
	}

	/*	Musimy jeszcze przestawi pare rzeczy.
		Najpierw - pokaza okno na ekranie,
		Potem - przestawi priorytet wtku (bo
		poszczeglne okna w Windows s w wtkach - 
		dziwne?? ) na troch wyszy od normalnego.
		Ustawi okno, by reagowao na klawisze, oraz
		ostatecznie ustawi viewport prze metode
		Resize().
	*/
	Log.Log( "Koczenie okna..." );
	ShowWindow( *hWnd, SW_SHOW );
	SetForegroundWindow( *hWnd );
	SetFocus( *hWnd );
	Resize( ScrSize[0], ScrSize[1] );

	/*	I na kocu, kiedy kontekst jest ju ustawiony
		wreszcie mona pobra dane do RndInfo.
		Suy do tego funkcja glGetString(). Problem
		jest jedynie z tym, e std::string nie akceptuje
		domylnie typu const unsigned char* zwracanego przez
		t funkcje, ale konwersja pomaga :)
	*/
	Log.Log( "Pobieranie Informacji o sprzcie..." );
	RndInfo[0] = (char*)glGetString( GL_VERSION );
	RndInfo[1] = (char*)glGetString( GL_RENDERER );
	RndInfo[2] = (char*)glGetString( GL_VENDOR );
	RndInfo[3] = (char*)glGetString( GL_EXTENSIONS );
	Log.Report( "Wersja OpenGL: " + RndInfo[0] );
	Log.Report( "Sterownik: " + RndInfo[1] );
	Log.Report( "Dostawca: " + RndInfo[2] );

	// Hura! Sukces, nic si nie sypneo :)
	return true;
}

void UIRender::DisableGL()
{
	/*	Jeeli mamy kontekst OpenGL i nie jest
		on zerowy, to wypadao by go skasowa,
		ale najpierw trzeba zresetowa aktywny
		kontekst.
	*/
	if (hRC)
	{
		/*	btw: mona byo by przywrci kontekst jaki by poprzednio
			aktywny, ale to za duo roboty :P	*/
		if (!wglMakeCurrent(NULL,NULL))
		{
			// wtf?
			Log.FatalError( "Nie mona odczy kontekstu!" );
		}

		// Usuwamy kontekst OpenGL
		if (!wglDeleteContext(hRC))
		{
		    // Chyba nie chce :P
			Log.FatalError( "Nie mona usun kontekstu OpenGL!" );
		}
		hRC=NULL; // Zerujemy kontekst ( wtedy if go nie wychwyci przy nastpnym wywoaniu metody )
	}

	// Teraz usuwamy konteks aplikacji - wystarczy go tylko "puci" i ju bdzie wolny.
	if (hDC && !ReleaseDC(*hWnd,hDC))
	{
	    // Znowu???
		Log.FatalError( "Nie mona usun kontekstu aplikacji!" );
		hDC=NULL;	//Zerujemy kontekst
	}
}

/*	NISZCZENIE OKNA
	Tu wystarczy par prostych funkji, by posprzta
	po metodzie tworzenia okna.
	UWAGA: Gdy tracimy kontekst, to take tracimy
	wszytkie tekstury, list'y, itp. wic uywa z
	rozwag!
*/
void UIRender::GLDestroyWindow()
{
	Log.Log( "Niszczenie Okna" );
	/*	Jeeli ustawilimy peny ekran, to teraz
		Wypadao by go przywrci do normalnych
		ustawie. Dziki wczeniej wprowadzonej
		fladze CDS_FULLSCREEN teraz wystarczy
		wprowadzi dowoln warto by ekran
		wrci do porzdku.
	*/
	if (fullS)
	{
		Log.Report( "Przywracanie rozdzielczoci..." );
		ChangeDisplaySettings(NULL,0);	
		ShowCursor( true ); // Pokazujemy te kursor
	}

	DisableGL();

	// Teraz potrzeba usun okno
	if (*hWnd && !DestroyWindow(*hWnd))
	{
	    // alala kotki dwa
		Log.FatalError( "Nie mona usun okna!" );
		*hWnd=NULL;	//Zerujemy uchwyt okna
	}

	// wypadaoby jeszcze odrejestrowa klas okna
	if (!UnregisterClass("OpenGL",hInstance))
	{
	    // zgadnijnie co?
		Log.FatalError( "Nie mona odrejestrowa klasy!" );
		hInstance=NULL;
	}

	IsWin = false;
	Log.Log( "Niszczenie okna zakoczone." );
}

void UIRender::Resize( unsigned int szerokosc, unsigned int wysokosc )
{
	if( wysokosc == 0 )	// Mae zabezpieczenie 
		wysokosc = 1;	// przed dzieleniem przez zero

	// Ustawiamy Viewport ( taki kwadrat, przez ktry bdziemy widzieli co OpenGL wykombinuje )
	glViewport( 0, 0, szerokosc, wysokosc);

	// W zalenoci czy mamy widok perspektywy, czy prostoktny, to musimy zresetowa matrix
	if( IsPers )
		SetPerspective( PerConf[0], szerokosc, wysokosc, PerConf[2], PerConf[3] );
	else SetOrtho();
}

/*	FUNKCJE USTAWIANIA PERSPEKTYWY
	Napisaem te metody, bo nie chce
	mi si wklepywa caej reguki, a
	poza tym, w taki sposb program
	bdzie atwo pamita ustawienia.
	UWAGA: Po wywoaniu tych funkcji
	zostaje zresetowany aktualny ukad
	wsprzdnych!
*/
void UIRender::SetPerspective( float kat, int szerokosc, int wysokosc, float blisko, float daleko )
{
	if( wysokosc == 0 )	// Zabezpieczenie, przed 
		wysokosc = 1;	// dzieleniem przez zero

	SetPerspective( kat, ( (float)szerokosc / (float)wysokosc ), blisko, daleko );
}

void UIRender::SetPerspective( float kat, float wspl, float blisko, float daleko )
{
	// Zapisanie do wartoci domylnych, by atwo mona byo
	// Przeancza si midzy typami rzutw
	PerConf[0] = kat;
	PerConf[1] = wspl;
	PerConf[2] = blisko;
	PerConf[3] = daleko;

	SetPerspective();
}

void UIRender::SetPerspective()
{
	// A tu jest ta reguka ;)

	// Przestawienie trybu matrix'a
	glMatrixMode( GL_PROJECTION );

	//Reset ukadu wsprzdnych
	glLoadIdentity();	

	//Ustawienie Perspektywy ( Kt widzenia, Rozmiar ekranu, Min widocznoci, Max widocznoci )
	gluPerspective( PerConf[0], PerConf[1], PerConf[2], PerConf[3] );

	//Znowu zmiana Matrix'a
	glMatrixMode(GL_MODELVIEW);	
	
	//I reset ukadu
	glLoadIdentity();
}

/*	FUNKCJE USTAWIANIA RZUT. PROSTOKTNEGO
	To samo, jak przy perspektywie
	tutaj, dziki tym funkcj, bdzie
	atwiej si przeczy w tryb
	2D ( by np. dobrze pisa po
	ekranie ). A co oznaczaj parametry?
	Jest to tzw. brya przycinania i
	wszystko co jest rysowane poza ni
	jest wanie przycinane. Dodatkowo
	ostatnie dwa maj wartoci domylne,
	bo praktycznie s rzadko uywane.
*/
void UIRender::SetOrtho( float lewo, float prawo, float dol, float gora, float blisko, float daleko )
{
	// Przypisanie nowych wartoci do tablicy
	OrthoConf[0] = lewo;
	OrthoConf[1] = prawo;
	OrthoConf[2] = dol;
	OrthoConf[3] = gora;
	OrthoConf[4] = blisko;
	OrthoConf[5] = daleko;

	// Wywoanie waciwej funkcji
	SetOrtho();
}

void UIRender::SetOrtho()
{
	/*	Jak wida, ta funkcja niewiele si rni
		od funkcji perspektywy. Dla czytelnoci
		( i moich palcw :P ) omin niektre 
		zbdne komentarze.
	*/

	glMatrixMode( GL_PROJECTION );

	glLoadIdentity();	

	//Ustawienie Rzut. Prostoktnego ( dla rozszyfrowania parametrw patrz -> deklaracja tablicy OrthoConf )
	glOrtho( OrthoConf[0], OrthoConf[1], OrthoConf[2], OrthoConf[3], OrthoConf[4], OrthoConf[5] ); 

	glMatrixMode(GL_MODELVIEW);	
	
	glLoadIdentity();
}

/*	ZAMIANA BUFORW
	Caa idea podwjnego buforowania
	( Double Buffering ) polega na
	dwch miejscach pamici na karcie
	graficznej - przedniej ( widocznej
	na ekranie ) i tylnej ( niewidocznej ).
	Cay trik polega na tym, e tworzymy 
	ca klatk animacji w buforze tylnym
	i zamieniamy bufory miejscami. Dziki
	temu nie ma wraenia migania i animacja
	jest pynna. Ta funkcja jest "obudwk"
	dla waciwej funkcji podmiany buforw
	( dla prostoty ).
*/
void UIRender::SwitchBuf()
{
	SwapBuffers(hDC);
}

/*	FUNKCJE DO KOMUNIKACJI POZA KLAS	*/
const int UIRender::GetWidth()
{
	return ScrSize[0];
}

const int UIRender::GetHeight()
{
	return ScrSize[1];
}

std::string UIRender::GetRndInfo( unsigned int info )
{
	if( info > 3 )
		return "INVALID INFO";

	return RndInfo[info];
}

bool UIRender::GetFullScreen()
{
	return fullS;
}

void UIRender::EnableFullScreen()
{
	if( fullS )
		return;

	SetWindowLong( *hWnd, GWL_STYLE, WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN );
	SetWindowLong( *hWnd, GWL_EXSTYLE, WS_EX_APPWINDOW );
	ShowCursor( false );
	// struktura trzymajca konfiguracje zmiany parametrw ekranu			
	DEVMODE dmScreenSettings;

    // Musimy t struktur przeczyci (nadpisa zerami), by nie mie adnych niespodzianek					
	memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	
	dmScreenSettings.dmSize=sizeof(dmScreenSettings);
	
    //ustawiamy strukture	
	dmScreenSettings.dmPelsWidth	= ScrSize[0];	//Szeroko ekranu
	dmScreenSettings.dmPelsHeight	= ScrSize[1];	//Wysoko ekranu
	dmScreenSettings.dmBitsPerPel	= 32;		//Gbia kolorw

	// Ostatnie ustawienie mwi, co zrobi z Pixelami
	dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

	/*	Prba zmiany rozdzielczoci (CDS_FULLSCREEN usuwa 
		panel startu, oraz przywraca star konfiguracje ekranu
		przy kolejnej prbie zmiany rozdzielczo )
	*/
	Log.Log( "Zmiana rozdzielczoci" );
	if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
	{
		Log.Error( "Nie mona zmieni rozdzielczoci!" );
		//Jeeli nieudana, proponujemy dziaanie okienkowe
		if (MessageBox(NULL,"Nie mona zmieni rozdzielczoci. Prawdopodobnie\ntwoja karta graficzna nie obsuguje trybu Penoekranowego.\nUy trybu okienkowego?","OpenGL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
		{
			Log.Report( "Zmiana trybu na Okienkowy" );
            //Jeeli tak to wykonujemy
			fullS = false;
		}
		else
		{
			//Jeeli nie to koczymy dziaanie (dajemy komunikat, e progam zostanie zamknity)
			MessageBox(NULL,"Program zostanie zamknity.","BD",MB_OK|MB_ICONSTOP);
			Log.Report( "Wyczenie aplikacji" );
			return;	//przerywamy dziaanie aplikacji
		}
	}

	RECT		WindowRect;				//Wielko okna (struktura czworoboku)
	WindowRect.left		= (long)0;			//Lewa krawd na 0
	WindowRect.right	= (long)ScrSize[0];	//Prawa krawd na warto Szerokosc
	WindowRect.top		= (long)0;			//Grna krawd na 0
	WindowRect.bottom	= (long)ScrSize[1];	//Dolna krawd na warto Wysokosc

	AdjustWindowRectEx( &WindowRect, WS_POPUP, false, WS_EX_APPWINDOW );		

	SetWindowPos( *hWnd, HWND_TOP, WindowRect.left, WindowRect.top, WindowRect.right, WindowRect.bottom, SWP_SHOWWINDOW );
	ShowWindow( *hWnd, SW_SHOW );

	fullS = true;
}

void UIRender::DisableFullScreen()
{
	if( !fullS )
		return;

	SetWindowLong( *hWnd, GWL_STYLE, WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN );
	SetWindowLong( *hWnd, GWL_EXSTYLE, WS_EX_APPWINDOW | WS_EX_WINDOWEDGE );
	ShowCursor( true );
	RECT		WindowRect;				//Wielko okna (struktura czworoboku)
	WindowRect.left		= (long)0;			//Lewa krawd na 0
	WindowRect.right	= (long)ScrSize[0];	//Prawa krawd na warto Szerokosc
	WindowRect.top		= (long)0;			//Grna krawd na 0
	WindowRect.bottom	= (long)ScrSize[1];	//Dolna krawd na warto Wysokosc

	AdjustWindowRectEx( &WindowRect, WS_OVERLAPPEDWINDOW, false, WS_EX_APPWINDOW | WS_EX_WINDOWEDGE );		

	SetWindowPos( *hWnd, HWND_TOP, 0, 0, WindowRect.right, WindowRect.bottom, SWP_SHOWWINDOW );

	Log.Report( "Przywracanie rozdzielczoci..." );
	ChangeDisplaySettings(NULL,0);	
	ShowWindow( *hWnd, SW_SHOW );

	fullS = false;
}

void UIRender::VSync( unsigned int set )
{
/*	PFNWGLSWAPINTERVALPROC   wglSwapIntervalEXT; 
	wglSwapIntervalEXT    = (PFNWGLSWAPINTERVALPROC) wglGetProcAddress("wglSwapIntervalEXT"); 
	if( wglSwapIntervalEXT )wglSwapIntervalEXT(set);*/
}