#ifndef _SPECIAL_H_
#define _SPECIAL_H_

#include "gui.h"
#include "3dMath.h"
#include "Level.h"
#include "vector"

class specEffect
{
public:
	bool Visible;
	bool CanDelete;
	specEffect();
	virtual void DoEngine();
	virtual void DoDraw();
};

class specRay : public specEffect
{
private:
	float Alpha;
public:
	Vector3f FromPos;
	Vector3f ToPos;

	void Create( Vector3f Pos, Vector3f Veloc );

	void DoDraw();
	void DoEngine();
};

class specExplode : public specEffect
{
private:
	float toPower;
	float thisPower;
	float Step;
	float Alpha;	
public:
	Vector3f FromPos;

	void Create( Vector3f Pos, float Power, float fStep );

	void DoDraw();
	void DoEngine();
};

class specSprite : public specEffect
{
private:
	float Alpha;
	ioTexture Tex;
	float C[3];
public:
	Vector3f AtPos;

	void Create( Vector3f Pos, float R = 1.0f, float G = 1.0f, float B = 1.0f );

	void DoDraw();
	void DoEngine();
};

class specManager
{
private:
	std::vector<specEffect*> List;
public:
	int MaxSpec;
	
	void AddEffect( specEffect* effect );
	void DeleteEffect( unsigned int index );
	specEffect* GetEffect( unsigned int index );
	
	void DoEngine();
	void DoDraw();
};

class specMotionBlur
{
private:
	unsigned int texture[5];
	bool inited;
	bool CanCopy;
	unsigned short CurTex;
	unsigned short tick;
	unsigned int list;
public:
	specMotionBlur();
	~specMotionBlur();
	void Init();
	void CopyImage();
	void DoEngine();
	void DoDraw();
	void Free();
};

extern specManager SEManager;
extern ioTexture Part;
extern specMotionBlur SMBlur;

#endif