#include "main.h"

bool Init()    //Inicjalizacja OpenGL
{
	glDepthFunc( GL_LEQUAL );				//Metoda testowania Gbokoci (ta jest lepsza)
	glEnable( GL_TEXTURE_2D );
	GUI.InitGUI();
	GUI.SetLoadLevelFunc( LoadLevel );
	GUI.SendConMsg( "=====EXPERT 3D TOURNAMENT ENGINE=====", false );
	GUI.SendConMsg( "STEROWNIK: " + GLRender.GetRndInfo( RENDER_RENDERER ), false );
	GUI.SendConMsg( "WERSJA: " + GLRender.GetRndInfo( RENDER_VERSION ), false );
	GUI.SendConMsg( "INICJALIZACJA GLOWNA", false );

	GUI.SendConMsg( "Ustawianie OpenGL...", false );
	glShadeModel( GL_SMOOTH );			    //Ustawienie adnego cieniowania
	glClearColor( 0.0f, 0.0f, 0.0f, 0.5f );	//Ustawienie koloru czyszczenia bufora kolorw
	glClearDepth( 1.0f );					//Ustwienie glbokoci czyszczenia bufora gbokoci
	glEnable( GL_DEPTH_TEST );				//Wczenie testowania Pixeli na gboko
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
	glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );//Najlepsze obliczenia perspektywy
	glHint( GL_LINE_SMOOTH_HINT, GL_NICEST );
	glHint( GL_FOG_HINT, GL_NICEST );
	glHint( GL_POINT_SMOOTH_HINT, GL_NICEST );
	glHint( GL_POLYGON_SMOOTH_HINT, GL_NICEST );

	Vector3f Normal, Point;
	Point.Set( 0.0f, -5.01f, 0.0f );
	Normal.Set( 0.0f, 1.0f, 0.0f );
	double p1[] = { 0.0, 1.0, 0.0, -Point.Dot( Normal ) };
	double p2[] = { 0.0, -1.0, 0.0, -Point.Dot( Normal.Reverse() ) };
	glClipPlane( GL_CLIP_PLANE0, p1 );
	glClipPlane( GL_CLIP_PLANE1, p2 );

	glEnable( GL_CLIP_PLANE0 );
	//glEnable( GL_CLIP_PLANE1 );

	glEnable( GL_COLOR_MATERIAL );
	glEnable( GL_CULL_FACE );

	/*	Na tym prowadziem testy z owietleniem. Jak kto jest ciekaw
		jakby to wygldao, to niech odkomentuje te linie.
	*/
	/*
		float lDiffuse[] = { 0.7f, 0.7f, 0.7f, 1.0f };
		float lSpecular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		float lAmbient[] = { 0.1f, 0.1f, 0.1f, 1.0f };
		glLightfv( GL_LIGHT0, GL_DIFFUSE, lDiffuse );
		glLightfv( GL_LIGHT0, GL_AMBIENT, lAmbient );
		glLightfv( GL_LIGHT0, GL_SPECULAR, lSpecular );
		glLightfv( GL_LIGHT1, GL_DIFFUSE, lDiffuse );
		glLightfv( GL_LIGHT1, GL_AMBIENT, lAmbient );
		glLightfv( GL_LIGHT1, GL_SPECULAR, lSpecular );
		glEnable( GL_LIGHTING );
	*/
	GUI.SendConMsg( "Zakonczono", false );

	GUI.SendConMsg( "Inicjalizacja silnika...", false );
	SMBlur.Init();
	Part.LoadTGA( "Data/Part.tga" );
	MenuModel = GLMManager.Get( "Data/menumodel.glm" );
	MainPlayer.SetArmor( 100.0f );
	GUI.Menu.LoadMenu( "Data/menu.mnu" );
	SEManager.MaxSpec = 100;

	GUI.SendConMsg( "Zakonczono", false );
	GUI.SendConMsg( "INICJALIZACJA GLOWNA ZAKONCZONA", false );
	GUI.Menu.Enable();

	return true; //zwracamy, e wszystko OK
}

void DoEngine()
{
	Mouse();
	unsigned int flags = 0;
	MainPlayer.DoEngine( Keys );
	if( GUI.GetCliping() )
	{
		MainPlayer.ModHealth( -BManager.DoTest( &MainPlayer, MainPlayer.GetArmor() ) );
		WManager.DoEngine( &MainPlayer, 1 );
	}
	ThingManager.DoEngine();
	BManager.DoEngine();
	GUI.PInfo.HEALTH = MainPlayer.GetHealth();
	GUI.PInfo.ARMOR = MainPlayer.GetArmor();
	MainPlayer.ApplyNextPos();
	GUI.PInfo.angle = MainPlayer.GetAng();
	SEManager.DoEngine();
	SMBlur.DoEngine();
}

void DoDraw()
{
	int i;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//Czyszczenie buforw
	if( GUI.GetMotionBlur() )
	{
		GLRender.Resize( 512, 512 );
		GLRender.SetPerspective( GUI.GetEyeAngle(), 4, 3, 1.0f, 100.0f );
		glLoadIdentity();	//Reset ukadu wsprzdnych

		glRotatef( MainPlayer.GetAng(), 0.0f, 1.0f, 0.0f );
		glTranslatef( -MainPlayer.Pos.X, 0, -MainPlayer.Pos.Z );

		GLevel.DrawLevel();
		ThingManager.DoDraw();
		glColor4f( 1.0f, 1.0f, 1.0f ,1.0f );
		WManager.DoDraw();
		BManager.DoDraw();
		glDepthMask( 0 );
		SEManager.DoDraw();
		GLevel.DrawReflect();
		glDepthMask( 1 );

		GLRender.SetPerspective( 45.0f, 4, 3, 1.0f, 10.0f );
		glClear( GL_DEPTH_BUFFER_BIT );	//Czyszczenie buforw
		glLoadIdentity();
		MainPlayer.DoDraw();
		
		glFlush();

		SMBlur.CopyImage();
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//Czyszczenie buforw
		GLRender.Resize( GLRender.GetWidth(), GLRender.GetHeight() );
	}

	GLRender.SetPerspective( GUI.GetEyeAngle(), 4, 3, 1.0f, 100.0f );
	glLoadIdentity();	//Reset ukadu wsprzdnych

	glRotatef( MainPlayer.GetAng(), 0.0f, 1.0f, 0.0f );
	glTranslatef( -MainPlayer.Pos.X, 0, -MainPlayer.Pos.Z );

	//float lPos[] = { 5.0f, 2.0f, -35.0f, 1.0f };
	//glLightfv( GL_LIGHT0, GL_POSITION, lPos );
	GLevel.DrawLevel();
	ThingManager.DoDraw();
	glColor4f( 1.0f, 1.0f, 1.0f ,1.0f );
	WManager.DoDraw();
	BManager.DoDraw();
	glDepthMask( 0 );
	SEManager.DoDraw();
	GLevel.DrawReflect();
	glDepthMask( 1 );

	GLRender.SetPerspective( 45.0f, 4, 3, 1.0f, 10.0f );
	glClear( GL_DEPTH_BUFFER_BIT );	//Czyszczenie buforw
	glLoadIdentity();
	MainPlayer.DoDraw();

	if( GUI.GetMotionBlur() )
		SMBlur.DoDraw();

	glFlush();
}

bool Render()		//Gwna funkcja renderujca
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//Czyszczenie buforw
	static float rot = 0.0f;
	GUI.ParseKeys( Keys );
	GUI.DoGUIEngine();
	if( GUI.CanDoMainEng() )
		for( int i = 0; i < GUI.GetEPFTimes(); i++ )
			DoEngine();

	if( GUI.CanDoMainDraw() )
		DoDraw();
	if( GUI.Menu.IsEnabled() && !GLevel.GetLoaded() )
	{
		GLRender.SetPerspective( GUI.GetEyeAngle(), 4, 3, 1.0f, 100.0f );
		glLoadIdentity();	//Reset ukadu wsprzdnych
		rot += 0.01f;
		glTranslatef( 0.0f, 0.0f, -10.0f );
		MenuModel->CallObject( 1 );
		glRotatef( rot, 0.5f, 0.5f, 1.0f );
		MenuModel->CallObject( 0 );
	}
	GUI.DoGUIDraw();

	return true;//zwracamy, e wszystko OK
}

/*	PORUSZANIE MYSZ
	By wychwyci ruch myszy posuymy si WinApi.
	Zrezygnowaem z Input'sw, bo tylko namieszay
	by w kodzie :P.
*/
void Mouse()
{
	/*	Najpierw standardowa strukturka windows.
		Jest to eee... PUNKT :) ktry zawiera A
		2 skadowe ( x, y ) :P
	*/
	POINT mpos;

	/*	Teraz musimy mie punk oparcia o ile ruszono
		mysz. Ja wybraem rodek ekranu, z td
		korzystam z klasy UIRender by uzyska szeroko
		i wysoko oraz dziele je na p.
	*/
	int m_wid = GLRender.GetWidth() / 2;
	int m_hei = GLRender.GetHeight() / 2;

	// Dwie zmienne pomocnicze, trzymajce stopie wychylenia
	float mov_x;// mov_y,

	/*	Uywamy piknej funkcji Windows, by wychwyci poorzenie
		kursora wzgldem okna.
	*/
	GetCursorPos( &mpos );

	/*	Wyliczamy rznice midzy poorzeniem 
		punktu na ekranie, a rodkiem ekranu
		i zmniejszamy j dziesiciokrotnie.
		( byaby za dua ).
	*/
	mov_x = (float)(mpos.x - m_wid) / 10.0f;

	/*	Modyfikujemy stopie obrotu gracza.	*/
	MainPlayer.ModAngle( mov_x );

	// W kocu ustawiamy kursor na rodek ekranu.
	SetCursorPos( m_wid, m_hei );
}

/*	FUNKCJA KOMUNIKATW
	By okno sprawnie pracowao, potrzebna
	jest funkcja komunikatw, tzw. Window Processing.
	Interpretujemy tutaj komunikaty by okno, np. Zmienio
	szeroko. Tu wanie si pojawia znany problem "Program
	Nie Odpowiada", bo pewnie jest tak zajty, e nie ma czasu
	uruchomi funkcji komunikatw.
*/
LRESULT CALLBACK WndProc(	HWND	hWnd,			// Uchwyt do okna
							UINT	uMsg,			// Komunikaty
							WPARAM	wParam,			// Dodatkowe informacje
							LPARAM	lParam)			// Dodatkowe informacje
{
	switch (uMsg)									// Sprawd komunikaty
	{
		case WM_ACTIVATE:							// komunikar Aktywnoci
		{
			if (!HIWORD(wParam))					// Sprawd altywno
			{
				active=true;						// Program jest aktywny
			}
			else
			{
				active=false;						// Program ju nie jest aktywny
			}

			return 0;								// Spowrotem do ptli
		}

		case WM_SYSCOMMAND:							// Sprawd komunikaty systemowe
		{
			switch (wParam)	
			{
				case SC_SCREENSAVE:					// Wygaszaczprbuje si wczy?
				case SC_MONITORPOWER:				// Monitor prbuje wczy oszczdzanie prdu?
				return 0;							// Zapobiegaj
			}
			break;									// wyjd
		}

		case WM_CLOSE:								// Komunikat zamknicia
		{
			PostQuitMessage(0);						// Wysyamy zamknicie
			return 0;								
		}

		case WM_LBUTTONDOWN:
		{
			Keys[VK_LBUTTON] = true;
			return 0;
		}

		case WM_LBUTTONUP:
		{
			Keys[VK_LBUTTON] = false;
			return 0;
		}

		case WM_RBUTTONDOWN:
		{
			Keys[VK_RBUTTON] = true;
			return 0;
		}

		case WM_RBUTTONUP:
		{
			Keys[VK_RBUTTON] = false;
			return 0;
		}

		case WM_KEYDOWN:							// Klawisz jest nacinienity?
		{
			GUI.ParseKey( (char)wParam );
			Keys[wParam] = true;					// Zaznacz e jest wcinity
			return 0;								
		}

		case WM_KEYUP:								// Klawisz jest puszczony?
		{
			Keys[wParam] = false;					// Zaznacz e jest wolny
			return 0;								
		}

		case WM_SIZE:								// Zmiana rozmiarw
		{
			GLRender.Resize(LOWORD(lParam),HIWORD(lParam));  // LoWord=szeroko, HiWord=wysoko
			return 0;								
		}
	}

	// przeka reszte komunikatw do DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instancja
					HINSTANCE	hPrevInstance,		// Poprzednia instancja
					LPSTR		lpCmdLine,			// Parametry
					int			nCmdShow)			// Tryb widocznoci okna
{
	MSG		msg;									// Struktura komunikatw windowsa
	bool	done = false;	// bool do wyjcia z ptli

	Log.Init( "main.log", " - Expert 3D Tournament Log" );

	// Czytamy plik ini, by odpowiednio wszystko ustawi
	MyIniFile ini;
	ini.Open( "config.ini" );
	int Szer = ini.ReadInt( "GRAPHIC", "WIDTH", 640 );
	int Wys = ini.ReadInt( "GRAPHIC", "HEIGHT", 480 );
	fullscreen = ini.ReadBool( "GRAPHIC", "FULLSCREEN", false );
	GUI.SetMaxSpecial( ini.ReadInt( "SPECIAL", "MAXCOUNT", 0 ) );
	GUI.SetCanSmoke( ini.ReadBool( "SPECIAL", "SMOKE", true ) );
	ini.Close();

	// Spytaj o tryb ekranu
	/*
	if (MessageBox(NULL,"Czy chcesz wczy tryb penoekranowy?", "Peny Ekran?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		Log.Log( "FULLSCR: FALSE" );
		fullscreen = false;							// Tryb okienkowy
	}
	else
	{
		Log.Log( "FULLSCR: TRUE" );
		fullscreen = true;
	}
	*/
	GLRender.SetWinHandle( &hWnd );

	// Stwrz okno
	if ( !GLRender.GLCreateWindow( "Expert 3D Tournament", Szer, Wys, fullscreen, (WNDPROC)WndProc ) )
	{
		return 0;									// Wyjd jeeli nie zostao stworzone
	}

	Log.Log( "Inicjalizacja OpenGL" );
	if( !Init() )
	{
		Log.Error( "Bd inicjalizacji" );
		return 0;
	}

	while(!done)									// Ptla gwna (dopuki done nie jest true)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Czy otrzymano komunikat?
		{
			if (msg.message==WM_QUIT)				// Czy to komunikat wyjcia?
			{
				done = true;							// Jeeli tak to wychodzimy z ptli
			}
			else									// Jeeli nie to zajmij si komunikatami
			{
				TranslateMessage(&msg);				// Tumacz komunikat
				DispatchMessage(&msg);				// Wykonaj komunikat
			}
		}
		else										// Jeeli nie ma komunikatw
		{
			GUI.UpdateCounter();
			// Rysujemy scene
			if (active)								// Program jest aktywny?
			{
				if ( GUI.GetQuit() )				// Czy by wcinity ESC?
				{
					done = true;						// Jeeli tak to wychodzimy z ptli
				}
				else								// Jeeli nie to rysujemy
				{
					Render();						// Rysujemy scene
					GLRender.SwitchBuf();				// Przeanczamy bufory
				}

			}
			else
			{
				WaitMessage();
			}
		}
	}

	// Wyanczanie
	Log.Log( "Koniec pracy Aplikacji" );
	GLRender.GLDestroyWindow();									// Zniszcz okno
	return (msg.wParam);							// Wyjd z programu
}

void LoadLevel( std::string filename )
{
	FILE* fp = fopen( filename.c_str(), "r" );
	if( !fp )
	{
		GUI.SendConMsg( "Nie mozna znalesc pliku", false );
		return;
	}
	fclose( fp );

	GLevel.LoadLevel( filename );
	GLevel.InitLevel();
	GUI.LevName = GLevel.GetLevelName();
	WManager.LoadFromLevel();
	GUI.EnableMainEngine();
	GUI.EnableGGUI();
	/*
	if( StatObj != NULL )
		delete[] StatObj;
	if( GLevel.GetSObjCount() )
	{
		StatObj = new gameStatObj[GLevel.GetSObjCount()];
		int cur = 0;
		gameBlockInfo* Block;
		for( int i = 0; i < GLevel.GetBlockCount(); i++ )
		{
			Block = GLevel.GetBlock( i );
			if( Block->StatObj == "" )
				continue;
			
			StatObj[cur].LoadFromFile( Block->StatObj );
			StatObj[cur].Pos = GLevel.GetBlockPos( i );

			cur++;
		}
	}*/
}
